---
title: "Drag & Drop"
framework: javascript
version: "36.1.0"
---

# Drag & Drop

Drag & Drop is concerned with moving data around an application, or between applications, using the operating system drag and drop support. When using drag and drop, data is moved or copied around using MIME types in a way similar to using the clipboard.

Native drag and drop is typically used for moving data between applications, e.g. moving a URL from an email into a web browser to open the URL, or moving a file from a file explorer application to a text editor application. Native drag and drop is not typically used for operating on data inside an application. Native drag and drop is similar to clipboard functionality, e.g. data must be represented as MIME types and objects cannot be passed by reference (the data must be converted to a MIME type and copied).

This section outlines how the grid fits in with native operating system drag and drop. It is assumed the reader is familiar with how drag and drop works. If not, refer to one of the following introductions:

- [W3C Schools](https://www.w3schools.com/html/html5_draganddrop.asp)
- [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/API/HTML_Drag_and_Drop_API)

> **Note**
>
> This feature should be used when you need to export Grid Data to an external application or when browser drag events need to be used because there is no way to know where content might be dropped. For all basic scenarios such as dragging data between elements in the same page or grid to grid, the grid implements its own drag and drop separate to the operating system's drag and drop. It is used internally by the grid for [Row Dragging](https://www.ag-grid.com/javascript-data-grid/row-dragging/) (for reordering rows) and for column dragging (e.g. re-ordering columns or moving columns in the [Column Tool Panel](https://www.ag-grid.com/javascript-data-grid/tool-panel-columns/)). The grid uses its own implementation in these instances as it needs finer control over the data than native browser drag & drop supports. For example, the native d&d does not provide access to the dragged item until after the drag operation is complete.

## Enable Drag Source

To allow dragging from the grid, set the property `dndSource=true` on one of the columns. This will result in the column having a drag handle displayed. When the dragging starts, the grid will by default create a JSON representation of the data and set this as MIME types `application/json` and also `text/plain`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSource` | `boolean \| DndSourceCallback` |  | `false` | `boolean` or `Function`. Set to `true` (or return `true` from function) to allow dragging for native drag and drop. Module: [`DragAndDropModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

In the example below, note the following:

- The first column has `dndSource=true`, so staring a mouse drag on a cell in the first column will start a drag operation.
- When the data is dragged to the drop zone, the drop zone will display the received JSON. This is because the drop zone is programmed to accept `application/json` MIME types.
- You can also drag to other applications outside of the browser. For example, some text editors (eg Sublime Text) or word processors (eg Microsoft Word) will accept the drag based on the `text/plain` MIME type. You can test this by dragging a cell to e.g. Microsoft Word.

#### Simple

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  DragAndDropModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

const columnDefs: ColDef[] = [
  { valueGetter: "'Drag'", dndSource: true },
  { field: "id" },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  defaultColDef: {
    width: 80,
    filter: true,
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  rowData: getData(),
  rowDragManaged: true,
  columnDefs: columnDefs,
};

function onDragOver(event: any) {
  const dragSupported = event.dataTransfer.length;

  if (dragSupported) {
    event.dataTransfer.dropEffect = "move";
  }

  event.preventDefault();
}

function onDrop(event: any) {
  const jsonData = event.dataTransfer.getData("application/json");

  const eJsonRow = document.createElement("div");
  eJsonRow.classList.add("json-row");
  eJsonRow.innerText = jsonData;

  const eJsonDisplay = document.querySelector("#eJsonDisplay")!;

  eJsonDisplay.appendChild(eJsonRow);
  event.preventDefault();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onDragOver = onDragOver;
  (<any>window).onDrop = onDrop;
}
```

[Live example: Simple](https://www.ag-grid.com/examples/drag-and-drop/simple/typescript)

## Dragging Between Grids

It is possible to drag rows between two instances of AG Grid. The drag is done exactly like the simple case described above. The drop is done as demonstrated in the example below.

In the example below, note the following:

- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- If the row is already present in the grid, it will not be added twice. Again this is the choice of the example.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by dragging out from red, green and blue 'Create' draggable areas.

#### Two Grids

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  DragAndDropModule,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);
let rowIdSequence = 100;

const leftColumnDefs: ColDef[] = [
  { field: "id", dndSource: true },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];

const rightColumnDefs: ColDef[] = [
  { field: "id", dndSource: true },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];

let leftApi: GridApi;
const leftGridOptions: GridOptions = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  rowData: createLeftRowData(),
  rowDragManaged: true,
  columnDefs: leftColumnDefs,
};

let rightApi: GridApi;
const rightGridOptions: GridOptions = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  rowData: [],
  rowDragManaged: true,
  columnDefs: rightColumnDefs,
};

function createLeftRowData() {
  return ["Red", "Green", "Blue"].map(function (color) {
    return createDataItem(color);
  });
}

function createDataItem(color: string) {
  return {
    id: rowIdSequence++,
    color: color,
    value1: Math.floor(window.agRandom() * 100),
    value2: Math.floor(window.agRandom() * 100),
  };
}

function binDragOver(event: any) {
  const dragSupported = event.dataTransfer.types.length;

  if (dragSupported) {
    event.dataTransfer.dropEffect = "move";
    event.preventDefault();
  }
}

function binDrop(event: any) {
  event.preventDefault();

  const jsonData = event.dataTransfer.getData("application/json");
  const data = JSON.parse(jsonData);

  // if data missing or data has no id, do nothing
  if (!data || data.id == null) {
    return;
  }

  const transaction = {
    remove: [data],
  };

  const rowIsInLeftGrid = !!leftApi!.getRowNode(data.id);
  if (rowIsInLeftGrid) {
    leftApi!.applyTransaction(transaction);
  }

  const rowIsInRightGrid = !!rightApi!.getRowNode(data.id);
  if (rowIsInRightGrid) {
    rightApi!.applyTransaction(transaction);
  }
}

function dragStart(event: any, color: string) {
  const newItem = createDataItem(color);
  const jsonData = JSON.stringify(newItem);

  event.dataTransfer.setData("application/json", jsonData);
}

function gridDragOver(event: any) {
  const dragSupported = event.dataTransfer.types.length;

  if (dragSupported) {
    event.dataTransfer.dropEffect = "copy";
    event.preventDefault();
  }
}

function gridDrop(event: any, grid: string) {
  event.preventDefault();

  const jsonData = event.dataTransfer.getData("application/json");
  const data = JSON.parse(jsonData);

  // if data missing or data has no it, do nothing
  if (!data || data.id == null) {
    return;
  }

  const api = grid == "left" ? leftApi! : rightApi!;

  // do nothing if row is already in the grid, otherwise we would have duplicates
  const rowAlreadyInGrid = !!api!.getRowNode(data.id);
  if (rowAlreadyInGrid) {
    console.log("not adding row to avoid duplicates in the grid");
    return;
  }

  const transaction = {
    add: [data],
  };
  api.applyTransaction(transaction);
}

const leftGridDiv = document.querySelector<HTMLElement>("#eLeftGrid")!;
leftApi = createGrid(leftGridDiv, leftGridOptions);

const rightGridDiv = document.querySelector<HTMLElement>("#eRightGrid")!;
rightApi = createGrid(rightGridDiv, rightGridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).binDragOver = binDragOver;
  (<any>window).binDrop = binDrop;
  (<any>window).dragStart = dragStart;
  (<any>window).gridDragOver = gridDragOver;
  (<any>window).gridDrop = gridDrop;
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).binDragOver = binDragOver;
  (<any>window).binDrop = binDrop;
  (<any>window).dragStart = dragStart;
  (<any>window).gridDragOver = gridDragOver;
  (<any>window).gridDrop = gridDrop;
}
```

[Live example: Two Grids](https://www.ag-grid.com/examples/drag-and-drop/two-grids/typescript)

Note that there is no specific drop zone logic in the grid. This was done on purpose after analysis.

On initial analysis, consideration was given to exposing callbacks or firing events in the grid for the drop zone relevant events e.g. `onDragEnter`, `onDragExit` etc. However this did not add any additional value given that the developer can easily add such event listeners to the grid div directly.

Given that the grid would be simply exposing the underlying events / callbacks rather than doing any processing itself, it would not be adding any value and so providing such callbacks would just be adding a layer of useless logic.

## Custom Drag Data

It is possible that a JSON representation of the data is not what is required as the drag data.

To provide alternative drag data, use the `dndSourceOnRowDrag` callback on the column definition. This allows specific processing by the application for the `rowdrag` even rather than the default grid behaviour.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSourceOnRowDrag` | `DndSourceOnRowDragFunc` |  |  | Function to allow custom drag functionality for native drag and drop. Module: [`DragAndDropModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

The example below is identical to the first example on this page with the addition of custom drag data. Note the following:

- The draggable column also has `dndSourceOnRowDrag` set.
- The `onRowDrag` method provides an alternative piece of drag data to be set into the drag event.
- The data dragged also includes row state such as whether the rows is selected or not.

#### Custom Drag Data

```ts
import {
  ClientSideRowModelModule,
  DndSourceOnRowDragParams,
  DragAndDropModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  defaultColDef: {
    width: 80,
    filter: true,
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  rowData: getData(),
  rowDragManaged: true,
  columnDefs: [
    {
      valueGetter: "'Drag'",
      dndSource: true,
      dndSourceOnRowDrag: onRowDrag,
    },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ],
};

function onDragOver(event: any) {
  const dragSupported = event.dataTransfer.types.length;

  if (dragSupported) {
    event.dataTransfer.dropEffect = "move";
  }

  event.preventDefault();
}

function onDrop(event: any) {
  event.preventDefault();
  const jsonData = event.dataTransfer.getData("application/json");

  const eJsonRow = document.createElement("div");
  eJsonRow.classList.add("json-row");
  eJsonRow.innerText = jsonData;

  const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
  eJsonDisplay.appendChild(eJsonRow);
}

function onRowDrag(params: DndSourceOnRowDragParams) {
  // create the data that we want to drag
  const rowNode = params.rowNode;
  const e = params.dragEvent;
  const jsonObject = {
    grid: "GRID_001",
    operation: "Drag on Column",
    rowId: rowNode.data.id,
    selected: rowNode.isSelected(),
  };
  const jsonData = JSON.stringify(jsonObject);

  e.dataTransfer!.setData("application/json", jsonData);
  e.dataTransfer!.setData("text/plain", jsonData);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onDragOver = onDragOver;
  (<any>window).onDrop = onDrop;
}
```

[Live example: Custom Drag Data](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-data/typescript)

## Custom Drag Component

Drag and drop is a complex application-level requirement. As such, a component (the grid) can't propose a drag and drop solution that is appropriate for all applications. For this reason, if the application has drag and drop requirements, you would likely want to implement a custom [Cell Renderer](https://www.ag-grid.com/javascript-data-grid/component-cell-renderer/) specifically for your needs.

The example below shows a custom drag and drop cell renderer. Note the following:

- The dragging works similar to before, rows are dragged from the left grid to the right drop zone.
- The grid does not provide the dragging. Instead, the example's cell renderer implements the drag logic.

#### Custom Drag Component

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
import { DragSourceRenderer } from "./dragSourceRenderer";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

const rowClassRules = {
  "red-row": 'data.color == "Red"',
  "green-row": 'data.color == "Green"',
  "blue-row": 'data.color == "Blue"',
};

let gridApi: GridApi;

const gridOptions: GridOptions = {
  defaultColDef: {
    width: 80,
    filter: true,
  },
  rowClassRules: rowClassRules,
  rowData: getData(),
  rowDragManaged: true,
  columnDefs: [
    { cellRenderer: DragSourceRenderer, minWidth: 100 },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ],
};

function onDragOver(event: any) {
  const types = event.dataTransfer.types;

  const dragSupported = types.length;

  if (dragSupported) {
    event.dataTransfer.dropEffect = "move";
  }

  event.preventDefault();
}

function onDrop(event: any) {
  event.preventDefault();

  const textData = event.dataTransfer.getData("text/plain");
  const eJsonRow = document.createElement("div");
  eJsonRow.classList.add("json-row");
  eJsonRow.innerText = textData;

  const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
  eJsonDisplay.appendChild(eJsonRow);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onDragOver = onDragOver;
  (<any>window).onDrop = onDrop;
}
```

[Live example: Custom Drag Component](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-comp/typescript)


---
title: "Drag & Drop"
framework: angular
version: "36.1.0"
---

# Drag & Drop

Drag & Drop is concerned with moving data around an application, or between applications, using the operating system drag and drop support. When using drag and drop, data is moved or copied around using MIME types in a way similar to using the clipboard.

Native drag and drop is typically used for moving data between applications, e.g. moving a URL from an email into a web browser to open the URL, or moving a file from a file explorer application to a text editor application. Native drag and drop is not typically used for operating on data inside an application. Native drag and drop is similar to clipboard functionality, e.g. data must be represented as MIME types and objects cannot be passed by reference (the data must be converted to a MIME type and copied).

This section outlines how the grid fits in with native operating system drag and drop. It is assumed the reader is familiar with how drag and drop works. If not, refer to one of the following introductions:

- [W3C Schools](https://www.w3schools.com/html/html5_draganddrop.asp)
- [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/API/HTML_Drag_and_Drop_API)

> **Note**
>
> This feature should be used when you need to export Grid Data to an external application or when browser drag events need to be used because there is no way to know where content might be dropped. For all basic scenarios such as dragging data between elements in the same page or grid to grid, the grid implements its own drag and drop separate to the operating system's drag and drop. It is used internally by the grid for [Row Dragging](https://www.ag-grid.com/angular-data-grid/row-dragging/) (for reordering rows) and for column dragging (e.g. re-ordering columns or moving columns in the [Column Tool Panel](https://www.ag-grid.com/angular-data-grid/tool-panel-columns/)). The grid uses its own implementation in these instances as it needs finer control over the data than native browser drag & drop supports. For example, the native d&d does not provide access to the dragged item until after the drag operation is complete.

## Enable Drag Source

To allow dragging from the grid, set the property `dndSource=true` on one of the columns. This will result in the column having a drag handle displayed. When the dragging starts, the grid will by default create a JSON representation of the data and set this as MIME types `application/json` and also `text/plain`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSource` | `boolean \| DndSourceCallback` |  | `false` | `boolean` or `Function`. Set to `true` (or return `true` from function) to allow dragging for native drag and drop. Module: [`DragAndDropModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

In the example below, note the following:

- The first column has `dndSource=true`, so staring a mouse drag on a cell in the first column will start a drag operation.
- When the data is dragged to the drop zone, the drop zone will display the received JSON. This is because the drop zone is programmed to accept `application/json` MIME types.
- You can also drag to other applications outside of the browser. For example, some text editors (eg Sublime Text) or word processors (eg Microsoft Word) will accept the drag based on the `text/plain` MIME type. You can test this by dragging a cell to e.g. Microsoft Word.

#### Simple

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DragAndDropModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="outer">
    <div class="grid-col">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [rowClassRules]="rowClassRules"
        [rowData]="rowData"
        [rowDragManaged]="true"
      />
    </div>

    <div
      class="drop-col"
      (dragover)="onDragOver($event)"
      (drop)="onDrop($event)"
    >
      <span id="eDropTarget" class="drop-target"> ==&gt; Drop to here </span>
      <div id="eJsonDisplay" class="json-display"></div>
    </div>
  </div> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { valueGetter: "'Drag'", dndSource: true },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ];
  defaultColDef: ColDef = {
    width: 80,
    filter: true,
  };
  rowClassRules: RowClassRules = {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  };
  rowData: any[] | null = getData();

  onDragOver(event: any) {
    const dragSupported = event.dataTransfer.length;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
    }
    event.preventDefault();
  }

  onDrop(event: any) {
    const jsonData = event.dataTransfer.getData("application/json");
    const eJsonRow = document.createElement("div");
    eJsonRow.classList.add("json-row");
    eJsonRow.innerText = jsonData;
    const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
    eJsonDisplay.appendChild(eJsonRow);
    event.preventDefault();
  }
}
```

[Live example: Simple](https://www.ag-grid.com/examples/drag-and-drop/simple/angular)

## Dragging Between Grids

It is possible to drag rows between two instances of AG Grid. The drag is done exactly like the simple case described above. The drop is done as demonstrated in the example below.

In the example below, note the following:

- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- If the row is already present in the grid, it will not be added twice. Again this is the choice of the example.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by dragging out from red, green and blue 'Create' draggable areas.

#### Two Grids

```ts
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  DragAndDropModule,
  ModuleRegistry,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="outer">
      <div
        style="height: 100%;"
        class="inner-col"
        (dragover)="gridDragOver($event)"
        (drop)="gridDrop($event, 'left')"
      >
        <ag-grid-angular
          style="height: 100%"
          [gridOptions]="leftGridOptions"
          [columnDefs]="columnDefs"
          (gridReady)="onGridReady($event, 'left')"
        >
        </ag-grid-angular>
      </div>

      <div class="inner-col factory-panel">
        <span
          id="eBin"
          (dragover)="binDragOver($event)"
          (drop)="binDrop($event)"
          class="factory factory-bin"
        >
          <i class="far fa-trash-alt"
            ><span class="filename"> Trash - </span></i
          >
          Drop target to destroy row
        </span>
        <span
          draggable="true"
          (dragstart)="dragStart($event, 'Red')"
          class="factory factory-red"
        >
          <i class="far fa-plus-square"
            ><span class="filename"> Create - </span></i
          >
          Drag source for new red item
        </span>
        <span
          draggable="true"
          (dragstart)="dragStart($event, 'Green')"
          class="factory factory-green"
        >
          <i class="far fa-plus-square"
            ><span class="filename"> Create - </span></i
          >
          Drag source for new green item
        </span>
        <span
          draggable="true"
          (dragstart)="dragStart($event, 'Blue')"
          class="factory factory-blue"
        >
          <i class="far fa-plus-square"
            ><span class="filename"> Create - </span></i
          >
          Drag source for new blue item
        </span>
      </div>

      <div
        style="height: 100%;"
        class="inner-col"
        (dragover)="gridDragOver($event)"
        (drop)="gridDrop($event, 'right')"
      >
        <ag-grid-angular
          style="height: 100%"
          [gridOptions]="rightGridOptions"
          [columnDefs]="columnDefs"
          (gridReady)="onGridReady($event, 'right')"
        >
        </ag-grid-angular>
      </div>
    </div>
  `,
})
export class AppComponent {
  private leftGridApi!: GridApi;
  private rightGridApi!: GridApi;

  rowIdSequence = 100;

  columnDefs: ColDef[] = [
    { field: "id", dndSource: true },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ];

  leftGridOptions: GridOptions = {
    defaultColDef: {
      flex: 1,
      filter: true,
    },
    rowClassRules: {
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    },
    getRowId: (params) => {
      return String(params.data.id);
    },
    rowData: this.createLeftRowData(),
    rowDragManaged: true,
  };

  rightGridOptions: GridOptions = {
    defaultColDef: {
      flex: 1,
      filter: true,
    },
    rowClassRules: {
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    },
    getRowId: (params) => {
      return String(params.data.id);
    },
    rowData: [],
    rowDragManaged: true,
  };

  createLeftRowData() {
    const data: any[] = [];
    ["Red", "Green", "Blue"].forEach((color) => {
      data.push(this.createDataItem(color));
    });
    return data;
  }

  createDataItem(color: string) {
    return {
      id: this.rowIdSequence++,
      color: color,
      value1: Math.floor(window.agRandom() * 100),
      value2: Math.floor(window.agRandom() * 100),
    };
  }

  binDragOver(event: any) {
    const dragSupported =
      event.dataTransfer.types.indexOf("application/json") >= 0;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
      event.preventDefault();
    }
  }

  binDrop(event: any) {
    event.preventDefault();
    const jsonData = event.dataTransfer.getData("application/json");
    const data = JSON.parse(jsonData);

    // if data missing or data has no id, do nothing
    if (!data || data.id == null) {
      return;
    }

    const transaction = {
      remove: [data],
    };

    const rowIsInLeftGrid = !!this.leftGridApi.getRowNode(data.id);
    if (rowIsInLeftGrid) {
      this.leftGridApi.applyTransaction(transaction);
    }

    const rowIsInRightGrid = !!this.rightGridApi.getRowNode(data.id);
    if (rowIsInRightGrid) {
      this.rightGridApi.applyTransaction(transaction);
    }
  }

  dragStart(event: any, color: string) {
    const newItem = this.createDataItem(color);
    const jsonData = JSON.stringify(newItem);
    event.dataTransfer.setData("application/json", jsonData);
  }

  gridDragOver(event: any) {
    const dragSupported = event.dataTransfer.types.length;

    if (dragSupported) {
      event.dataTransfer.dropEffect = "copy";
      event.preventDefault();
    }
  }

  gridDrop(event: any, grid: string) {
    event.preventDefault();

    const jsonData = event.dataTransfer.getData("application/json");
    const data = JSON.parse(jsonData);

    // if data missing or data has no it, do nothing
    if (!data || data.id == null) {
      return;
    }

    const gridApi = grid == "left" ? this.leftGridApi : this.rightGridApi;

    // do nothing if row is already in the grid, otherwise we would have duplicates
    const rowAlreadyInGrid = !!gridApi!.getRowNode(data.id);
    if (rowAlreadyInGrid) {
      console.log("not adding row to avoid duplicates in the grid");
      return;
    }

    const transaction = {
      add: [data],
    };
    gridApi!.applyTransaction(transaction);
  }

  onGridReady(params: GridReadyEvent, grid: "left" | "right") {
    if (grid === "left") {
      this.leftGridApi = params.api;
    } else {
      this.rightGridApi = params.api;
    }
  }
}
```

[Live example: Two Grids](https://www.ag-grid.com/examples/drag-and-drop/two-grids/angular)

Note that there is no specific drop zone logic in the grid. This was done on purpose after analysis.

On initial analysis, consideration was given to exposing callbacks or firing events in the grid for the drop zone relevant events e.g. `onDragEnter`, `onDragExit` etc. However this did not add any additional value given that the developer can easily add such event listeners to the grid div directly.

Given that the grid would be simply exposing the underlying events / callbacks rather than doing any processing itself, it would not be adding any value and so providing such callbacks would just be adding a layer of useless logic.

## Custom Drag Data

It is possible that a JSON representation of the data is not what is required as the drag data.

To provide alternative drag data, use the `dndSourceOnRowDrag` callback on the column definition. This allows specific processing by the application for the `rowdrag` even rather than the default grid behaviour.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSourceOnRowDrag` | `DndSourceOnRowDragFunc` |  |  | Function to allow custom drag functionality for native drag and drop. Module: [`DragAndDropModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

The example below is identical to the first example on this page with the addition of custom drag data. Note the following:

- The draggable column also has `dndSourceOnRowDrag` set.
- The `onRowDrag` method provides an alternative piece of drag data to be set into the drag event.
- The data dragged also includes row state such as whether the rows is selected or not.

#### Custom Drag Data

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DndSourceOnRowDragParams,
  DragAndDropModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="outer">
    <div class="grid-col">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [defaultColDef]="defaultColDef"
        [rowClassRules]="rowClassRules"
        [rowData]="rowData"
        [rowDragManaged]="true"
        [columnDefs]="columnDefs"
      />
    </div>

    <div
      class="drop-col"
      (dragover)="onDragOver($event)"
      (drop)="onDrop($event)"
    >
      <span id="eDropTarget" class="drop-target"> ==&gt; Drop to here </span>
      <div id="eJsonDisplay" class="json-display"></div>
    </div>
  </div> `,
})
export class AppComponent {
  defaultColDef: ColDef = {
    width: 80,
    filter: true,
  };
  rowClassRules: RowClassRules = {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  };
  rowData: any[] | null = getData();
  columnDefs: ColDef[] = [
    {
      valueGetter: "'Drag'",
      dndSource: true,
      dndSourceOnRowDrag: onRowDrag,
    },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ];

  onDragOver(event: any) {
    const dragSupported = event.dataTransfer.types.length;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
    }
    event.preventDefault();
  }

  onDrop(event: any) {
    event.preventDefault();
    const jsonData = event.dataTransfer.getData("application/json");
    const eJsonRow = document.createElement("div");
    eJsonRow.classList.add("json-row");
    eJsonRow.innerText = jsonData;
    const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
    eJsonDisplay.appendChild(eJsonRow);
  }
}

function onRowDrag(params: DndSourceOnRowDragParams) {
  // create the data that we want to drag
  const rowNode = params.rowNode;
  const e = params.dragEvent;
  const jsonObject = {
    grid: "GRID_001",
    operation: "Drag on Column",
    rowId: rowNode.data.id,
    selected: rowNode.isSelected(),
  };
  const jsonData = JSON.stringify(jsonObject);
  e.dataTransfer!.setData("application/json", jsonData);
  e.dataTransfer!.setData("text/plain", jsonData);
}
```

[Live example: Custom Drag Data](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-data/angular)

## Custom Drag Component

Drag and drop is a complex application-level requirement. As such, a component (the grid) can't propose a drag and drop solution that is appropriate for all applications. For this reason, if the application has drag and drop requirements, you would likely want to implement a custom [Cell Renderer](https://www.ag-grid.com/angular-data-grid/component-cell-renderer/) specifically for your needs.

The example below shows a custom drag and drop cell renderer. Note the following:

- The dragging works similar to before, rows are dragged from the left grid to the right drop zone.
- The grid does not provide the dragging. Instead, the example's cell renderer implements the drag logic.

#### Custom Drag Component

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);
import { DragSourceRenderer } from "./drag-source-renderer.component";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, DragSourceRenderer],
  template: `<div class="outer">
    <div class="grid-col">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [rowClassRules]="rowClassRules"
        [defaultColDef]="defaultColDef"
        [rowData]="rowData"
        [rowDragManaged]="true"
        [columnDefs]="columnDefs"
      />
    </div>

    <div
      class="drop-col"
      (dragover)="onDragOver($event)"
      (drop)="onDrop($event)"
    >
      <span id="eDropTarget" class="drop-target"> ==&gt; Drop to here </span>
      <div id="eJsonDisplay" class="json-display"></div>
    </div>
  </div> `,
})
export class AppComponent {
  rowClassRules: RowClassRules = {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  };
  defaultColDef: ColDef = {
    width: 80,
    filter: true,
  };
  rowData: any[] | null = getData();
  columnDefs: ColDef[] = [
    { cellRenderer: DragSourceRenderer, minWidth: 100 },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ];

  onDragOver(event: any) {
    const types = event.dataTransfer.types;
    const dragSupported = types.length;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
    }
    event.preventDefault();
  }

  onDrop(event: any) {
    event.preventDefault();
    const textData = event.dataTransfer.getData("text/plain");
    const eJsonRow = document.createElement("div");
    eJsonRow.classList.add("json-row");
    eJsonRow.innerText = textData;
    const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
    eJsonDisplay.appendChild(eJsonRow);
  }
}
```

[Live example: Custom Drag Component](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-comp/angular)


---
product: "AG Grid"
title: "Drag & Drop"
description: "Drag & Drop is concerned with moving data around an application, or between applications, using the operating system drag and drop support. When using drag and drop, data is moved or copied around using MIME types in a way similar to using the clipboard."
framework: vue
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/vue-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/vue-data-grid/excel-export/"
    - title: "Excel Import"
      url: "https://www.ag-grid.com/vue-data-grid/excel-import/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/vue-data-grid/pdf-export/"
    - title: "Clipboard"
      url: "https://www.ag-grid.com/vue-data-grid/clipboard/"
    - title: "Printing"
      url: "https://www.ag-grid.com/vue-data-grid/printing/"
llms: "https://www.ag-grid.com/llms.txt"
---

# Drag & Drop

Drag & Drop is concerned with moving data around an application, or between applications, using the operating system drag and drop support. When using drag and drop, data is moved or copied around using MIME types in a way similar to using the clipboard.

Native drag and drop is typically used for moving data between applications, e.g. moving a URL from an email into a web browser to open the URL, or moving a file from a file explorer application to a text editor application. Native drag and drop is not typically used for operating on data inside an application. Native drag and drop is similar to clipboard functionality, e.g. data must be represented as MIME types and objects cannot be passed by reference (the data must be converted to a MIME type and copied).

This section outlines how the grid fits in with native operating system drag and drop. It is assumed the reader is familiar with how drag and drop works. If not, refer to one of the following introductions:

- [W3C Schools](https://www.w3schools.com/html/html5_draganddrop.asp)
- [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/API/HTML_Drag_and_Drop_API)

> **Note**
>
> This feature should be used when you need to export Grid Data to an external application or when browser drag events need to be used because there is no way to know where content might be dropped. For all basic scenarios such as dragging data between elements in the same page or grid to grid, the grid implements its own drag and drop separate to the operating system's drag and drop. It is used internally by the grid for [Row Dragging](https://www.ag-grid.com/vue-data-grid/row-dragging/) (for reordering rows) and for column dragging (e.g. re-ordering columns or moving columns in the [Column Tool Panel](https://www.ag-grid.com/vue-data-grid/tool-panel-columns/)). The grid uses its own implementation in these instances as it needs finer control over the data than native browser drag & drop supports. For example, the native d&d does not provide access to the dragged item until after the drag operation is complete.

## Enable Drag Source

To allow dragging from the grid, set the property `dndSource=true` on one of the columns. This will result in the column having a drag handle displayed. When the dragging starts, the grid will by default create a JSON representation of the data and set this as MIME types `application/json` and also `text/plain`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSource` | `boolean \| DndSourceCallback` |  |  |  |

In the example below, note the following:

- The first column has `dndSource=true`, so staring a mouse drag on a cell in the first column will start a drag operation.
- When the data is dragged to the drop zone, the drop zone will display the received JSON. This is because the drop zone is programmed to accept `application/json` MIME types.
- You can also drag to other applications outside of the browser. For example, some text editors (eg Sublime Text) or word processors (eg Microsoft Word) will accept the drag based on the `text/plain` MIME type. You can test this by dragging a cell to e.g. Microsoft Word.

#### Simple

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DragAndDropModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="outer">
      <div class="grid-col">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :rowClassRules="rowClassRules"
          :rowData="rowData"
          :rowDragManaged="true"></ag-grid-vue>
        </div>
        <div class="drop-col" v-on:dragover="onDragOver($event)" v-on:drop="onDrop($event)">
          <span id="eDropTarget" class="drop-target"> ==&gt; Drop to here </span>
          <div id="eJsonDisplay" class="json-display"></div>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { valueGetter: "'Drag'", dndSource: true },
      { field: "id" },
      { field: "color" },
      { field: "value1" },
      { field: "value2" },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 80,
      filter: true,
    });
    const rowClassRules = ref<RowClassRules>({
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    });
    const rowData = ref<any[] | null>(getData());

    function onDragOver(event: any) {
      const dragSupported = event.dataTransfer.length;
      if (dragSupported) {
        event.dataTransfer.dropEffect = "move";
      }
      event.preventDefault();
    }
    function onDrop(event: any) {
      const jsonData = event.dataTransfer.getData("application/json");
      const eJsonRow = document.createElement("div");
      eJsonRow.classList.add("json-row");
      eJsonRow.innerText = jsonData;
      const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
      eJsonDisplay.appendChild(eJsonRow);
      event.preventDefault();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowClassRules,
      rowData,
      onGridReady,
      onDragOver,
      onDrop,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Simple](https://www.ag-grid.com/examples/drag-and-drop/simple/vue3/)

## Dragging Between Grids

It is possible to drag rows between two instances of AG Grid. The drag is done exactly like the simple case described above. The drop is done as demonstrated in the example below.

In the example below, note the following:

- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- If the row is already present in the grid, it will not be added twice. Again this is the choice of the example.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by dragging out from red, green and blue 'Create' draggable areas.

#### Two Grids

```ts
import { createApp, defineComponent } from "vue";

import type { ColDef, GridApi, GridOptions } from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  DragAndDropModule,
  ModuleRegistry,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

import "./style.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: /* html */ `
        <div class="outer">
            <div style="height: 100%" class="inner-col" v-on:dragover="gridDragOver($event)" v-on:drop="gridDrop($event, 'left')">
                <ag-grid-vue
                    style="height: 100%; width: 100%;"
                    ref="leftGrid"
                    :gridOptions="leftGridOptions"
                    :columnDefs="leftColumnDefs"
                    :rowClassRules="rowClassRules"
                    :rowData="leftRowData"
                    :rowDragManaged="true">
                </ag-grid-vue>
            </div>
            <div class="inner-col factory-panel">
                <span id="eBin" class="factory factory-bin" v-on:dragover="binDragOver($event)" v-on:drop="binDrop($event)">
                    <i class="far fa-trash-alt"><span class="filename"> Trash - </span></i>
                    Drop target to destroy row
                    </span>
                <span draggable="true" class="factory factory-red" v-on:dragstart="dragStart($event, 'Red')">
                    <i class="far fa-plus-square"><span class="filename"> Create - </span></i>
                    Drag source for new red item
                </span>
                <span draggable="true" class="factory factory-green" v-on:dragstart="dragStart($event, 'Green')">
                    <i class="far fa-plus-square"><span class="filename"> Create - </span></i>
                    Drag source for new green item
                </span>
                <span draggable="true" class="factory factory-blue" v-on:dragstart="dragStart($event, 'Blue')">
                    <i class="far fa-plus-square"><span class="filename"> Create - </span></i>
                    Drag source for new blue item
                </span>
            </div>
            <div style="height: 100%" class="inner-col" v-on:dragover="gridDragOver($event)" v-on:drop="gridDrop($event, 'right')">
                <ag-grid-vue
                    style="height: 100%; width: 100%"
                    ref="rightGrid"
                    :gridOptions="rightGridOptions"
                    :columnDefs ="rightColumnDefs"
                    :rowClassRules="rowClassRules"
                    :rowData="rightRowData"
                    :rowDragManaged="true">
                </ag-grid-vue>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data: function () {
    return {
      leftGridOptions: null,
      rightGridOptions: null,
      leftGridApi: null,
      rightGridApi: null,
      leftColumnDefs: null,
      rightColumnDefs: null,
      rowClassRules: null,
      leftRowData: null,
      rightRowData: null,
      rowIdSequence: 100,
    };
  },
  beforeMount() {
    const baseDefaultColDef = <ColDef>{
      flex: 1,
      filter: true,
    };

    const baseGridOptions = <GridOptions>{
      getRowId: (params) => {
        return String(params.data.id);
      },
      rowDragManaged: true,
    };

    const baseColumnDefs = <ColDef[]>[
      { field: "id", dndSource: true },
      { field: "color" },
      { field: "value1" },
      { field: "value2" },
    ];

    this.leftColumnDefs = [...baseColumnDefs];
    this.rightColumnDefs = [...baseColumnDefs];

    this.leftRowData = this.createRowData();
    this.rightRowData = [];

    this.leftGridOptions = <GridOptions>{
      ...baseGridOptions,
      defaultColDef: {
        ...baseDefaultColDef,
      },
    };

    this.rightGridOptions = <GridOptions>{
      ...baseGridOptions,
      rowData: [],
      defaultColDef: {
        ...baseDefaultColDef,
      },
    };

    this.rowClassRules = {
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    };
  },

  mounted() {
    this.leftGridApi = <GridApi>this.$refs.leftGrid.api;
    this.rightGridApi = <GridApi>this.$refs.rightGrid.api;
  },

  methods: {
    createRowData() {
      return ["Red", "Green", "Blue"].map((color) =>
        this.createDataItem(color),
      );
    },

    createDataItem(color) {
      return {
        id: this.rowIdSequence++,
        color: color,
        value1: Math.floor(window.agRandom() * 100),
        value2: Math.floor(window.agRandom() * 100),
      };
    },

    dragStart($event, color) {
      var newItem = this.createDataItem(color);
      var jsonData = JSON.stringify(newItem);

      event.dataTransfer.setData("application/json", jsonData);
    },

    gridDragOver($event) {
      var dragSupported = event.dataTransfer.types.length;

      if (dragSupported) {
        event.dataTransfer.dropEffect = "copy";
        event.preventDefault();
      }
    },

    gridDrop($event, grid) {
      event.preventDefault();

      var jsonData = event.dataTransfer.getData("application/json");
      var data = JSON.parse(jsonData);

      // if data missing or data has no it, do nothing
      if (!data || data.id == null) {
        return;
      }

      var gridApi = grid == "left" ? this.leftGridApi : this.rightGridApi;

      // do nothing if row is already in the grid, otherwise we would have duplicates
      var rowAlreadyInGrid = !!gridApi.getRowNode(data.id);
      if (rowAlreadyInGrid) {
        console.log("not adding row to avoid duplicates in the grid");
        return;
      }

      var transaction = {
        add: [data],
      };
      gridApi.applyTransaction(transaction);
    },

    binDragOver($event) {
      var dragSupported = event.dataTransfer.types.length;

      if (dragSupported) {
        event.dataTransfer.dropEffect = "move";
        event.preventDefault();
      }
    },

    binDrop($event) {
      event.preventDefault();

      var jsonData = event.dataTransfer.getData("application/json");
      var data = JSON.parse(jsonData);

      // if data missing or data has no id, do nothing
      if (!data || data.id == null) {
        return;
      }

      var transaction = {
        remove: [data],
      };

      var rowIsInLeftGrid = !!this.leftGridApi.getRowNode(data.id);
      if (rowIsInLeftGrid) {
        this.leftGridApi.applyTransaction(transaction);
      }

      var rowIsInRightGrid = !!this.rightGridApi.getRowNode(data.id);
      if (rowIsInRightGrid) {
        this.rightGridApi.applyTransaction(transaction);
      }
    },
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Two Grids](https://www.ag-grid.com/examples/drag-and-drop/two-grids/vue3/)

Note that there is no specific drop zone logic in the grid. This was done on purpose after analysis.

On initial analysis, consideration was given to exposing callbacks or firing events in the grid for the drop zone relevant events e.g. `onDragEnter`, `onDragExit` etc. However this did not add any additional value given that the developer can easily add such event listeners to the grid div directly.

Given that the grid would be simply exposing the underlying events / callbacks rather than doing any processing itself, it would not be adding any value and so providing such callbacks would just be adding a layer of useless logic.

## Custom Drag Data

It is possible that a JSON representation of the data is not what is required as the drag data.

To provide alternative drag data, use the `dndSourceOnRowDrag` callback on the column definition. This allows specific processing by the application for the `rowdrag` even rather than the default grid behaviour.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSourceOnRowDrag` | `DndSourceOnRowDragFunc` |  |  |  |

The example below is identical to the first example on this page with the addition of custom drag data. Note the following:

- The draggable column also has `dndSourceOnRowDrag` set.
- The `onRowDrag` method provides an alternative piece of drag data to be set into the drag event.
- The data dragged also includes row state such as whether the rows is selected or not.

#### Custom Drag Data

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DndSourceOnRowDragParams,
  DragAndDropModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

function onRowDrag(params: DndSourceOnRowDragParams) {
  // create the data that we want to drag
  const rowNode = params.rowNode;
  const e = params.dragEvent;
  const jsonObject = {
    grid: "GRID_001",
    operation: "Drag on Column",
    rowId: rowNode.data.id,
    selected: rowNode.isSelected(),
  };
  const jsonData = JSON.stringify(jsonObject);
  e.dataTransfer!.setData("application/json", jsonData);
  e.dataTransfer!.setData("text/plain", jsonData);
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="outer">
      <div class="grid-col">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :defaultColDef="defaultColDef"
          :rowClassRules="rowClassRules"
          :rowData="rowData"
          :rowDragManaged="true"
          :columnDefs="columnDefs"></ag-grid-vue>
        </div>
        <div class="drop-col" v-on:dragover="onDragOver($event)" v-on:drop="onDrop($event)">
          <span id="eDropTarget" class="drop-target"> ==&gt; Drop to here </span>
          <div id="eJsonDisplay" class="json-display"></div>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const defaultColDef = ref<ColDef>({
      width: 80,
      filter: true,
    });
    const rowClassRules = ref<RowClassRules>({
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    });
    const rowData = ref<any[] | null>(getData());
    const columnDefs = ref<ColDef[]>([
      {
        valueGetter: "'Drag'",
        dndSource: true,
        dndSourceOnRowDrag: onRowDrag,
      },
      { field: "id" },
      { field: "color" },
      { field: "value1" },
      { field: "value2" },
    ]);

    function onDragOver(event: any) {
      const dragSupported = event.dataTransfer.types.length;
      if (dragSupported) {
        event.dataTransfer.dropEffect = "move";
      }
      event.preventDefault();
    }
    function onDrop(event: any) {
      event.preventDefault();
      const jsonData = event.dataTransfer.getData("application/json");
      const eJsonRow = document.createElement("div");
      eJsonRow.classList.add("json-row");
      eJsonRow.innerText = jsonData;
      const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
      eJsonDisplay.appendChild(eJsonRow);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      defaultColDef,
      rowClassRules,
      rowData,
      columnDefs,
      onGridReady,
      onDragOver,
      onDrop,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Drag Data](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-data/vue3/)

## Custom Drag Component

Drag and drop is a complex application-level requirement. As such, a component (the grid) can't propose a drag and drop solution that is appropriate for all applications. For this reason, if the application has drag and drop requirements, you would likely want to implement a custom [Cell Renderer](https://www.ag-grid.com/vue-data-grid/component-cell-renderer/) specifically for your needs.

The example below shows a custom drag and drop cell renderer. Note the following:

- The dragging works similar to before, rows are dragged from the left grid to the right drop zone.
- The grid does not provide the dragging. Instead, the example's cell renderer implements the drag logic.

#### Custom Drag Component

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import DragSourceRenderer from "./dragSourceRendererVue";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="outer">
      <div class="grid-col">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :rowClassRules="rowClassRules"
          :defaultColDef="defaultColDef"
          :rowData="rowData"
          :rowDragManaged="true"
          :columnDefs="columnDefs"></ag-grid-vue>
        </div>
        <div class="drop-col" v-on:dragover="onDragOver($event)" v-on:drop="onDrop($event)">
          <span id="eDropTarget" class="drop-target"> ==&gt; Drop to here </span>
          <div id="eJsonDisplay" class="json-display"></div>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    DragSourceRenderer,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const rowClassRules = ref<RowClassRules>({
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    });
    const defaultColDef = ref<ColDef>({
      width: 80,
      filter: true,
    });
    const rowData = ref<any[] | null>(getData());
    const columnDefs = ref<ColDef[]>([
      { cellRenderer: "DragSourceRenderer", minWidth: 100 },
      { field: "id" },
      { field: "color" },
      { field: "value1" },
      { field: "value2" },
    ]);

    function onDragOver(event: any) {
      const types = event.dataTransfer.types;
      const dragSupported = types.length;
      if (dragSupported) {
        event.dataTransfer.dropEffect = "move";
      }
      event.preventDefault();
    }
    function onDrop(event: any) {
      event.preventDefault();
      const textData = event.dataTransfer.getData("text/plain");
      const eJsonRow = document.createElement("div");
      eJsonRow.classList.add("json-row");
      eJsonRow.innerText = textData;
      const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
      eJsonDisplay.appendChild(eJsonRow);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      rowClassRules,
      defaultColDef,
      rowData,
      columnDefs,
      onGridReady,
      onDragOver,
      onDrop,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Drag Component](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-comp/vue3/)


---
title: "Drag & Drop"
framework: react
version: "36.1.0"
---

# Drag & Drop

Drag & Drop is concerned with moving data around an application, or between applications, using the operating system drag and drop support. When using drag and drop, data is moved or copied around using MIME types in a way similar to using the clipboard.

Native drag and drop is typically used for moving data between applications, e.g. moving a URL from an email into a web browser to open the URL, or moving a file from a file explorer application to a text editor application. Native drag and drop is not typically used for operating on data inside an application. Native drag and drop is similar to clipboard functionality, e.g. data must be represented as MIME types and objects cannot be passed by reference (the data must be converted to a MIME type and copied).

This section outlines how the grid fits in with native operating system drag and drop. It is assumed the reader is familiar with how drag and drop works. If not, refer to one of the following introductions:

- [W3C Schools](https://www.w3schools.com/html/html5_draganddrop.asp)
- [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/API/HTML_Drag_and_Drop_API)

> **Note**
>
> This feature should be used when you need to export Grid Data to an external application or when browser drag events need to be used because there is no way to know where content might be dropped. For all basic scenarios such as dragging data between elements in the same page or grid to grid, the grid implements its own drag and drop separate to the operating system's drag and drop. It is used internally by the grid for [Row Dragging](https://www.ag-grid.com/react-data-grid/row-dragging/) (for reordering rows) and for column dragging (e.g. re-ordering columns or moving columns in the [Column Tool Panel](https://www.ag-grid.com/react-data-grid/tool-panel-columns/)). The grid uses its own implementation in these instances as it needs finer control over the data than native browser drag & drop supports. For example, the native d&d does not provide access to the dragged item until after the drag operation is complete.

## Enable Drag Source

To allow dragging from the grid, set the property `dndSource=true` on one of the columns. This will result in the column having a drag handle displayed. When the dragging starts, the grid will by default create a JSON representation of the data and set this as MIME types `application/json` and also `text/plain`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSource` | `boolean \| DndSourceCallback` |  | `false` | `boolean` or `Function`. Set to `true` (or return `true` from function) to allow dragging for native drag and drop. Module: [`DragAndDropModule`](https://www.ag-grid.com/react-data-grid/modules/). |

In the example below, note the following:

- The first column has `dndSource=true`, so staring a mouse drag on a cell in the first column will start a drag operation.
- When the data is dragged to the drop zone, the drop zone will display the received JSON. This is because the drop zone is programmed to accept `application/json` MIME types.
- You can also drag to other applications outside of the browser. For example, some text editors (eg Sublime Text) or word processors (eg Microsoft Word) will accept the drag based on the `text/plain` MIME type. You can test this by dragging a cell to e.g. Microsoft Word.

#### Simple

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DragAndDropModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { valueGetter: "'Drag'", dndSource: true },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 80,
      filter: true,
    };
  }, []);
  const rowClassRules = useMemo<RowClassRules>(() => {
    return {
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    };
  }, []);

  const onDragOver = useCallback((event: any) => {
    const dragSupported = event.dataTransfer.length;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
    }
    event.preventDefault();
  }, []);

  const onDrop = useCallback((event: any) => {
    const jsonData = event.dataTransfer.getData("application/json");
    const eJsonRow = document.createElement("div");
    eJsonRow.classList.add("json-row");
    eJsonRow.innerText = jsonData;
    const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
    eJsonDisplay.appendChild(eJsonRow);
    event.preventDefault();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="outer">
          <div className="grid-col">
            <div style={gridStyle}>
              <AgGridReact
                rowData={rowData}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                rowClassRules={rowClassRules}
                rowDragManaged={true}
              />
            </div>
          </div>

          <div
            className="drop-col"
            onDragOver={() => onDragOver(event)}
            onDrop={() => onDrop(event)}
          >
            <span id="eDropTarget" className="drop-target">
              {" "}
              ==&gt; Drop to here{" "}
            </span>
            <div id="eJsonDisplay" className="json-display"></div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Simple](https://www.ag-grid.com/examples/drag-and-drop/simple/reactFunctionalTs)

## Dragging Between Grids

It is possible to drag rows between two instances of AG Grid. The drag is done exactly like the simple case described above. The drop is done as demonstrated in the example below.

In the example below, note the following:

- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- If the row is already present in the grid, it will not be added twice. Again this is the choice of the example.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by dragging out from red, green and blue 'Create' draggable areas.

#### Two Grids

```tsx
'use client';
import React, { StrictMode, useRef } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  DragAndDropModule,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  DragAndDropModule,
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
];

const baseDefaultColDef: ColDef = {
  flex: 1,
  filter: true,
};

const baseGridOptions: GridOptions = {
  getRowId: (params) => {
    return String(params.data.id);
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  rowDragManaged: true,
};

const baseColumnDefs: ColDef[] = [
  { field: "id", dndSource: true, width: 90 },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];

const leftGridOptions: GridOptions = {
  ...baseGridOptions,
  columnDefs: [...baseColumnDefs],
  defaultColDef: {
    ...baseDefaultColDef,
  },
};

const rightGridOptions: GridOptions = {
  ...baseGridOptions,
  columnDefs: [...baseColumnDefs],
  defaultColDef: {
    ...baseDefaultColDef,
  },
};

let nextRowId = 100;

const GridExample = () => {
  const leftGridRef = useRef<AgGridReact>(null);
  const rightGridRef = useRef<AgGridReact>(null);

  const onLeftGridReady = (params: GridReadyEvent) => {
    params.api.setGridOption("rowData", createLeftRowData());
  };

  const onRightGridReady = (params: GridReadyEvent) => {
    params.api.setGridOption("rowData", []);
  };

  const createLeftRowData = () => ["Red", "Green", "Blue"].map(createDataItem);

  const createDataItem = (color: string) => {
    const newDataItem = {
      id: nextRowId++,
      color: color,
      value1: Math.floor(window.agRandom() * 100),
      value2: Math.floor(window.agRandom() * 100),
    };

    return newDataItem;
  };

  const binDragOver = (event: any) => {
    const dragSupported =
      event.dataTransfer.types.indexOf("application/json") >= 0;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
      event.preventDefault();
    }
  };

  const binDrop = (event: any) => {
    event.preventDefault();
    const jsonData = event.dataTransfer.getData("application/json");
    const data = JSON.parse(jsonData);

    // if data missing or data has no id, do nothing
    if (!data || data.id == null) {
      return;
    }

    const transaction = {
      remove: [data],
    };

    const rowIsInLeftGrid = !!leftGridRef.current!.api.getRowNode(data.id);
    if (rowIsInLeftGrid) {
      leftGridRef.current!.api.applyTransaction(transaction);
    }

    const rowIsInRightGrid = !!rightGridRef.current!.api.getRowNode(data.id);
    if (rowIsInRightGrid) {
      rightGridRef.current!.api.applyTransaction(transaction);
    }
  };

  const dragStart = (color: string, event: any) => {
    const newItem = createDataItem(color);
    const jsonData = JSON.stringify(newItem);

    event.dataTransfer.setData("application/json", jsonData);
  };

  const gridDragOver = (event: any) => {
    const dragSupported = event.dataTransfer.types.length;

    if (dragSupported) {
      event.dataTransfer.dropEffect = "copy";
      event.preventDefault();
    }
  };

  const gridDrop = (grid: string, event: any) => {
    event.preventDefault();

    const jsonData = event.dataTransfer.getData("application/json");
    const data = JSON.parse(jsonData);

    // if data missing or data has no it, do nothing
    if (!data || data.id == null) {
      return;
    }

    const gridApi: GridApi =
      grid === "left" ? leftGridRef.current!.api : rightGridRef.current!.api;

    // do nothing if row is already in the grid, otherwise we would have duplicates
    const rowAlreadyInGrid = !!gridApi.getRowNode(data.id);
    if (rowAlreadyInGrid) {
      console.log("not adding row to avoid duplicates in the grid");
      return;
    }

    const transaction = {
      add: [data],
    };
    gridApi.applyTransaction(transaction);
  };

  return (
    <AgGridProvider modules={modules}>
      <div className="outer">
        <div
          style={{ height: "100%" }}
          className="inner-col"
          onDragOver={gridDragOver}
          onDrop={(e) => gridDrop("left", e)}
        >
          <AgGridReact
            ref={leftGridRef}
            gridOptions={leftGridOptions}
            onGridReady={onLeftGridReady}
          />
        </div>

        <div className="inner-col factory-panel">
          <span
            id="eBin"
            onDragOver={binDragOver}
            onDrop={binDrop}
            className="factory factory-bin"
          >
            <i className="far fa-trash-alt">
              <span className="filename"> Trash - </span>
            </i>
            Drop target to destroy row
          </span>
          <span
            draggable="true"
            onDragStart={(e) => dragStart("Red", e)}
            className="factory factory-red"
          >
            <i className="far fa-plus-square">
              <span className="filename"> Create - </span>
            </i>
            Drag source for new red item
          </span>
          <span
            draggable="true"
            onDragStart={(e) => dragStart("Green", e)}
            className="factory factory-green"
          >
            <i className="far fa-plus-square">
              <span className="filename"> Create - </span>
            </i>
            Drag source for new green item
          </span>
          <span
            draggable="true"
            onDragStart={(e) => dragStart("Blue", e)}
            className="factory factory-blue"
          >
            <i className="far fa-plus-square">
              <span className="filename"> Create - </span>
            </i>
            Drag source for new blue item
          </span>
        </div>

        <div
          style={{ height: "100%" }}
          className="inner-col"
          onDragOver={gridDragOver}
          onDrop={(e) => gridDrop("right", e)}
        >
          <AgGridReact
            ref={rightGridRef}
            gridOptions={rightGridOptions}
            onGridReady={onRightGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Two Grids](https://www.ag-grid.com/examples/drag-and-drop/two-grids/reactFunctionalTs)

Note that there is no specific drop zone logic in the grid. This was done on purpose after analysis.

On initial analysis, consideration was given to exposing callbacks or firing events in the grid for the drop zone relevant events e.g. `onDragEnter`, `onDragExit` etc. However this did not add any additional value given that the developer can easily add such event listeners to the grid div directly.

Given that the grid would be simply exposing the underlying events / callbacks rather than doing any processing itself, it would not be adding any value and so providing such callbacks would just be adding a layer of useless logic.

## Custom Drag Data

It is possible that a JSON representation of the data is not what is required as the drag data.

To provide alternative drag data, use the `dndSourceOnRowDrag` callback on the column definition. This allows specific processing by the application for the `rowdrag` even rather than the default grid behaviour.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `dndSourceOnRowDrag` | `DndSourceOnRowDragFunc` |  |  | Function to allow custom drag functionality for native drag and drop. Module: [`DragAndDropModule`](https://www.ag-grid.com/react-data-grid/modules/). |

The example below is identical to the first example on this page with the addition of custom drag data. Note the following:

- The draggable column also has `dndSourceOnRowDrag` set.
- The `onRowDrag` method provides an alternative piece of drag data to be set into the drag event.
- The data dragged also includes row state such as whether the rows is selected or not.

#### Custom Drag Data

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DndSourceOnRowDragParams,
  DragAndDropModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  DragAndDropModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
];

function onRowDrag(params: DndSourceOnRowDragParams) {
  // create the data that we want to drag
  const rowNode = params.rowNode;
  const e = params.dragEvent;
  const jsonObject = {
    grid: "GRID_001",
    operation: "Drag on Column",
    rowId: rowNode.data.id,
    selected: rowNode.isSelected(),
  };
  const jsonData = JSON.stringify(jsonObject);
  e.dataTransfer!.setData("application/json", jsonData);
  e.dataTransfer!.setData("text/plain", jsonData);
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 80,
      filter: true,
    };
  }, []);
  const rowClassRules = useMemo<RowClassRules>(() => {
    return {
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    };
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      valueGetter: "'Drag'",
      dndSource: true,
      dndSourceOnRowDrag: onRowDrag,
    },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ]);

  const onDragOver = useCallback((event: any) => {
    const dragSupported = event.dataTransfer.types.length;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
    }
    event.preventDefault();
  }, []);

  const onDrop = useCallback((event: any) => {
    event.preventDefault();
    const jsonData = event.dataTransfer.getData("application/json");
    const eJsonRow = document.createElement("div");
    eJsonRow.classList.add("json-row");
    eJsonRow.innerText = jsonData;
    const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
    eJsonDisplay.appendChild(eJsonRow);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="outer">
          <div className="grid-col">
            <div style={gridStyle}>
              <AgGridReact
                rowData={rowData}
                defaultColDef={defaultColDef}
                rowClassRules={rowClassRules}
                rowDragManaged={true}
                columnDefs={columnDefs}
              />
            </div>
          </div>

          <div
            className="drop-col"
            onDragOver={() => onDragOver(event)}
            onDrop={() => onDrop(event)}
          >
            <span id="eDropTarget" className="drop-target">
              {" "}
              ==&gt; Drop to here{" "}
            </span>
            <div id="eJsonDisplay" className="json-display"></div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Drag Data](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-data/reactFunctionalTs)

## Custom Drag Component

Drag and drop is a complex application-level requirement. As such, a component (the grid) can't propose a drag and drop solution that is appropriate for all applications. For this reason, if the application has drag and drop requirements, you would likely want to implement a custom [Cell Renderer](https://www.ag-grid.com/react-data-grid/component-cell-renderer/) specifically for your needs.

The example below shows a custom drag and drop cell renderer. Note the following:

- The dragging works similar to before, rows are dragged from the left grid to the right drop zone.
- The grid does not provide the dragging. Instead, the example's cell renderer implements the drag logic.

#### Custom Drag Component

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowClassRules,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
import DragSourceRenderer from "./dragSourceRenderer.tsx";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const rowClassRules = useMemo<RowClassRules>(() => {
    return {
      "red-row": 'data.color == "Red"',
      "green-row": 'data.color == "Green"',
      "blue-row": 'data.color == "Blue"',
    };
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 80,
      filter: true,
    };
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { cellRenderer: DragSourceRenderer, minWidth: 100 },
    { field: "id" },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ]);

  const onDragOver = useCallback((event: any) => {
    const types = event.dataTransfer.types;
    const dragSupported = types.length;
    if (dragSupported) {
      event.dataTransfer.dropEffect = "move";
    }
    event.preventDefault();
  }, []);

  const onDrop = useCallback((event: any) => {
    event.preventDefault();
    const textData = event.dataTransfer.getData("text/plain");
    const eJsonRow = document.createElement("div");
    eJsonRow.classList.add("json-row");
    eJsonRow.innerText = textData;
    const eJsonDisplay = document.querySelector("#eJsonDisplay")!;
    eJsonDisplay.appendChild(eJsonRow);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="outer">
          <div className="grid-col">
            <div style={gridStyle}>
              <AgGridReact
                rowData={rowData}
                rowClassRules={rowClassRules}
                defaultColDef={defaultColDef}
                rowDragManaged={true}
                columnDefs={columnDefs}
              />
            </div>
          </div>

          <div
            className="drop-col"
            onDragOver={() => onDragOver(event)}
            onDrop={() => onDrop(event)}
          >
            <span id="eDropTarget" className="drop-target">
              {" "}
              ==&gt; Drop to here{" "}
            </span>
            <div id="eJsonDisplay" className="json-display"></div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Drag Component](https://www.ag-grid.com/examples/drag-and-drop/custom-drag-comp/reactFunctionalTs)
